<template>
  <div class=" m-0 p-2 w-full mt-4 bg-gray-100 rounded-lg">
    <div class="row flex justify-between item-center pl-4 pr-4">
      <h4 class="font-bold self-center p-1">{{chapter.title}}</h4>
      <div class="row">
        <button v-if="!editing" class="btn btn-primary" @click="setEditing">EDIT</button>
        <button v-else class="btn btn-primary" @click="save">SAVE</button>
        <button class="btn btn-danger ml-2 mr-2" @click="deleteChapter">DELETE</button>
      </div>
    </div>

    <div class="pt-4" v-if="editing">
      <div class="input-group mb-3">
        <div class="input-group-prepend">
          <span class="input-group-text" id="inputGroup-sizing-default">Chapter Title</span>
        </div>
        <input v-model="title" type="text" class="form-control" aria-label="Sizing example input" aria-describedby="inputGroup-sizing-default">
      </div>
      <vue-editor class="pt-4"  v-model="htmlForEditor"></vue-editor>
    </div>
    <div v-else class=" p-4"  v-html="this.chapter.content"></div>
  </div>
</template>
<script>

  import Swal from "sweetalert2";

  export default {
    props:['chapter',
      'bookId'],
    data() {
      return {
        title:"Loading",
        editing:false,
        htmlForEditor: this.chapter.content,

      };
    },
    components: {

    },
    mounted(){
      this.bind()
    },methods: {
      bind(){
        const newChapter = Object.assign({}, this.chapter);
        this.title = newChapter.title
        console.log(this.title)
      },
      setEditorContent: function() {
        this.htmlForEditor = this.chapter;
      },
      setEditing: function() {
        this.editing = !this.editing
      },
      save:function (){
        const newChapter = Object.assign({}, this.chapter);
        newChapter.content = this.htmlForEditor
        newChapter.title = this.title
        this.$store.dispatch('Books/updateChapter', {chapter:newChapter, bookId:this.bookId})
        this.setEditing()
      },
      deleteChapter(){
        Swal.fire({
          title: 'Are you sure?',
          text: "You won't be able to revert this!",
          icon: 'warning',
          showCancelButton: true,
          confirmButtonColor: '#3085d6',
          cancelButtonColor: '#d33',
          confirmButtonText: 'Yes, delete it!'
        }).then((result) => {
          if (result.value) {
            const newChapter = Object.assign({}, this.chapter);
            this.$store.dispatch('Books/deleteChapter', {chapter:newChapter, bookId:this.bookId})
            Swal.fire(
              'Deleted!',
              'Your file has been deleted.',
              'success'
            )
          }
        })

      }
    }

  }
</script>

<style>
  .chapter{
    /*box-shadow: #7F828B 1px 1px 1px 1px;*/
  }
</style>
